<?php

	////////////////////////////////////////////////////////////////////////////////
	//
	// VBulletin Mailing List Generator Script 
	// Written by Aral Balkan (http://aralbalkan.com, aral@aralbalkan.com)
	// Released under CC-GNU GPL (http://creativecommons.org/licenses/GPL/2.0/)
	//
	// Creates a mailing list from VB users who have opted to receive
	// email and creates a tab-delimeted text file from them 
	// for use with Auto-Mailer (http://www.automsw.com/index.html).
	//
	// Make sure that there's a folder called output in the folder that this
	// script is in and make sure that it is writable.
	//
	// Please note that this script is in no way guaranteed to work
	// for your particular installation of VBulletin. 
	// Make sure you have backups of all your database before
	// trying it out and it is recommended that you run it on 
	// a non-deployment machine.
	//
	// USE AT YOUR OWN RISK! :)
	//
	////////////////////////////////////////////////////////////////////////////////

	// Include ezSQL core
	include_once 'ez_sql_core.php';

	// Include ezSQL database specific component
	include_once 'ez_sql_mysql.php';
	
	////////////////////////////////////////////////////////////////////////////////
	//
	// Enter the connection info for your VBulletin database below
	//
	////////////////////////////////////////////////////////////////////////////////

	// General database info 
	// Note: On my system, ez_sql didn't like my using the default root account
	// with no password. I'd recommend creating a db user account with a password
	// and granting it permissions for both your b2 and wp databases before running this script.
	$dbUser = '';
	$dbPass = '';
	$dbHost = '';
	
	// b2 database name
	$vbDatabase = '';	

	////////////////////////////////////////////////////////////////////////////////
	//
	// DO NOT CHANGE ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING!
	//
	////////////////////////////////////////////////////////////////////////////////

	echo '<h1>VBulletin Mailing List Generator for Auto-Mailer</h1>';
	echo '<i>Copyright (c) 2006 Aral Balkan. <a href="http://aralbalkan.com">http://aralbalkan.com</a>.<br /><br />';

	if ( $dbUser == '' || $dbPass == '' || $dbHost == '' || $vbDatabase == '' )
	{
		exit('<b>Error: Please configure the script with your database connection details before running it.</b>');  
	}
	
	//
	// Make database connection
	//
	$db = new ezSQL_mysql( $dbUser , $dbPass , $vbDatabase , $dbHost );

	//
	// Get the list of users that have opted to receive email
	//
	$vbSelectUsers = 'SELECT username,email FROM user WHERE (options & 16)';
	$vbUsers = $db->get_results ( $vbSelectUsers );

	// Create a text file in the output folder
	$f = fopen("output/mailing_list.txt", "w");

	// Write the headings to be used by Auto Mailer
	fwrite($f, "username\temail\r\n");

	// Write out the data in tab-delimited format
	foreach ( $vbUsers as $vbUser )
	{
		fwrite($f, $vbUser->username."\t".$vbUser->email."\r\n");
	}

	// Close the file
	fclose($f);
	
	// Provide a link to the file	
	echo '<b>Complete!</b> Download <a href="output/mailing_list.txt">mailing_list.txt</a> ('.round(filesize('output/mailing_list.txt')/1024) .'KB)';
?>